;----------------------------------------------------------------------------
; IDE BIOS nolimit patch Version 0.5 (C) 2025 ܂
;----------------------------------------------------------------------------
MSG_DISP_LINE   equ     12
PAT_ADDR_LEGACY equ     1C10h   ; 
PAT_ADDR_PCI4G  equ     1B40h   ; 
MEMseg          equ     6800h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗vӁI)
SND_equip       equ     80h     ; SND BIOS bit(A-mate,Multi)

; Global stack variables -----------------
COLOR_ATTRIB    equ     byte ptr [bp-3] ; \F
ROW             equ     word ptr [bp-4] ; \s
COLUMN          equ     word ptr [bp-6] ; \J
SegTVRAM        equ     word ptr [bp-8] ; T-VRAM̃ZOgA000/E000
SegPhysIDEBIOS  equ     word ptr [bp-10] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-12] ; IDE BIOSZOgiRAMmappingj
mem_bank_IOaddr equ     word ptr [bp-14] ; 0461h/0091h(nC])
MemWindowNative equ     byte ptr [bp-16] ; 08-BANK window native address
HiresoFlag      equ     byte ptr [bp-17] ; 01h Hi-reso flag (bit 0)
flagset         equ     byte ptr [bp-18]
StartLine       equ     byte ptr [bp-19] ;
equip           equ     byte ptr [bp-20] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
MemWindowAddr   equ     byte ptr [bp-21] ; 08-BANK window address in EXROM
MachineID       equ     byte ptr [bp-22] ; Machine ID
MachineType     equ     byte ptr [bp-23] ; PCI Machine type
CPUtype         equ     byte ptr [bp-24] ; 5=Pentium,4=i486,3=80386
; flsgset
F_HIRESO        equ     01h     ; nC][ĥƂ 1
F_GEN2          equ     02h     ; BIOS\Q,P̂Ƃ 1
F_GEN4          equ     04h     ; BIOS\ŜƂ 1
F_A1MATE        equ     08h     ; Ap,As,AêƂ 1
F_386           equ     10h     ; CPU 32bit
F_EPSON         equ     20h     ; EPSON@i286ȊOĵƂ 1
F_PCI2          equ     40h     ; igpjPCIzXg 430LXƂ
F_RW            equ     40h     ; igpj
F_H98           equ     80h     ; H98̂Ƃ 1

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                org 102h
title_msg       DB      0E1h,"IDE BIOSCHSeʌEpb`(ROM ع)  Version 0.9 (C)2025 ܂(DOSsoft)",13,10,0

.186
program_start:  
                enter   30,0
                cld
                mov     COLOR_ATTRIB,0E1h
                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     MachineType,al  ; =0
                mov     flagset,al
                call    CheckCPU386
                jc      ExitProgram
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
                jnc     @f
                call    CheckEPSONPC    ; EPSON@O
        @@:
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                jc      WrongMachine

                call    ModelCheck9821  ; @풲
                jc      WrongMachine

                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂
                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~

                call    PCI_existence   ; PCI bus Host邩HNCY
                jnc     PCI_Machine   ; CYĂ΋@Ⴂ
; 486_Machine (including BX4/Xe10)

                call    DisplayEquip
                mov     ax,SegMMapIDEBIOS
                call    IDEROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB
                test    flagset,F_GEN4
                jz      @f
                call    PatchPCI
                jc      WrongBIOS
                jmp     Patch486_end
        @@:
                test    flagset,F_A1MATE
                jz      @f
                call    PatchA1
                jc      WrongBIOS
                jmp     Patch486_end
                
        @@:     call    Patch486
                jc      WrongBIOS
                jmp     Patch486_end
Patch486_end:
                test    flagset,F_GEN2
                jz      PatchGen2Exit
                call    PatchGen2
    PatchGen2Exit:  
                call    MEMtoIDEBIOS_486 ; ̍ƌʂRAM BIOSɃRs[
                call    SetChkSum
                jmp     SuccessPatch

PCI_Machine:  ; (without BX4/Xe10)
                call    DisplayMachineType_PCI
                mov     SegMMapIDEBIOS,0D800h
                call    IDEROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB
                call    PatchPCI
                jc      WrongBIOS
                call    MEMtoIDEBIOS_PCI ; ̍ƌʂRAM BIOSɃRs[
SuccessPatch:   mov     dx,offset msg_sccess
                call    _puts
;                call    ClearMEMseg     ; ƃNAđދ
ExitProgram:
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~
                call    SetDisplayLine
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts   ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
CancelCTRL:     mov     dx,offset msg_CRLF
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      ;;call    Poop ; ````
                mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
;----------------------
absent_msg      DB      041h,"IDE BIOSoĂ܂ifBXN̐ڑj",13,10,0
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_sccess      DB     0E1h,"IDE BIOS̗eʔ胋[`Ƀpb`Ă܂.",13,10,0
msg_AvoidPatch  DB     0E1h," pb`𒆎~܂. ",13,10,0
msg_CRLF        DB     0E1h," ",13,10,0
msg_hireso      DB     0E1h," nC][h ",0
msg_h98         DB     041h," H98V[Y ",0
msg_epson       DB     041h," EPSON PCV[Y ",0
msg_rw          DB     0E1h," REDWOOD chipset ",0
;----------------------------------------------------------------


;------------------------------------------------------------
CopyData        PROC   near
                cld     ; MEM̃f[^RAMBIOSɃRs[
               push    es
                mov     es,SegMMapIDEBIOS
                mov     cx,2000h/2      ; 8KB
                sub     si,si
                mov     di,si
                mov     ax,MEMseg
               push    ds
                mov     ds,ax   ; ds=MEMseg, --> es=IDE BIOSRAMwindow
           rep  movsw
               pop     ds
               pop     es
                ret
CopyData        ENDP

;------------------------------------------------------------
MEMtoIDEBIOS_PCI    PROC   near
                pushf
                cli
                call    D800_RAM
                cld     ; MEM̃f[^RAMBIOSɃRs[
                call    CopyData
                call    D800_WP
                popf
                ret
MEMtoIDEBIOS_PCI    ENDP
;------------------------------------------------------------
MEMtoIDEBIOS_486    PROC   near
                call    ROMRAM486_IDE   ; ݒALbVtbV
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                pushf
                cli
                call    CopyData
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret
MEMtoIDEBIOS_486    ENDP
;------------------------------------------------------------
IDEROMtoMEM     PROC   near
                cld
                mov     cx,2000h/2      ; 8KB
                sub     si,si
                mov     di,si
                mov     ax,MEMseg
                push    es
                push    ds
                mov     es,ax   ; ES=AX=MEMseg
                mov     ds,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
          rep   movsw
                pop     ds
                pop     es
                ret
IDEROMtoMEM     ENDP
;=====================================
include Lim543MB.s
include patch486.s

;------------------------------
include machine.s
include patchpci.s
include pcipam.s
include memcopy.inc
include nolimcom.inc
include e:\asmlib\putstrCS.inc      ; \[`i\[X͕t܂j
;include numeric.inc
;------------------------------
DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0
DB      "ROM{[hROM̕ւ܂. (C)2025 DOSsoft",0,0
code    ends
        end     start
