;--------------------------------------------------------
;       DisplayTitle  ( Gen. p )
;--------------------------------------------------------
DisplayTitle    PROC    near

                mov     dx,offset title_msg
                call    _puts
                call    Erase1Line
                mov     dx,offset msg_machine_t
                call    _puts

                test    flagset,F_HIRESO
                jz      @f
                mov     dx,offset msg_hireso
                call    _puts
        @@:
                mov     dx,offset msg_epson
                test    flagset,F_EPSON
                jnz     @f
                mov     dx,offset msg_h98
                test    flagset,F_H98
                jnz     @f
                mov     dx,offset msg_rw
                test    flagset,F_RW
                jnz     @f
                CLC
                RET
        @@:     call    _puts
                STC
                RET
msg_machine_t   DB      0E1h,"@ ",0
DisplayTitle    ENDP


;--------------------------------------------------------
;       GetDisplayLine       input   ES = VRAM segment
;--------------------------------------------------------
GetDisplayLine  PROC    near
                xor     ax,ax
                mov     COLUMN,ax
                mov     ROW,MSG_DISP_LINE
                mov     bx,3FE0h                ; ITF\sǗAhX
                mov     al,es:[bx]
                cmp     al,MSG_DISP_LINE
                ja      LineIndicatorInvalid
                inc     ax
                mov     ROW,ax
LineIndicatorInvalid:
                mov     ax,ROW
                mov     StartLine,al
                ret
GetDisplayLine  ENDP

;--------------------------------------------------------
;       SetDisplayLine  
;--------------------------------------------------------
SetDisplayLine  PROC   near
                push    ds
                mov     ax,ROW
                mov     ds,SegTVRAM
                mov     ds:[3FE0h],al    ; [ITF\sǗAhX]
                pop     ds
                ret
SetDisplayLine  ENDP

;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
LoopPressShift: mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     LoopPressShift
                ret
ShiftKeyCheck   ENDP

;---------------------------------------------------------------------
;       Get segment address of IDE BIOS   ɂP񂾂R[
;---------------------------------------------------------------------
GetSeg_IDEBIOS  PROC    near
                xor     ax,ax
                push    ds
                mov     ds,ax
                mov     al,ds:[0457h]
                mov     ah,ds:[05B0h]
                pop     ds
;;;;;;;;;;;;    mov     WORK0457,al
;;;;;;;;;;;;    mov     WORK05B0,ah
                mov     al,flagset
                test    al,F_HIRESO ; --- Normal mode ---
                mov     cx,0DA00h   ; IDE work address (physical)
                mov     dx,0D800h   ; IDE BIOS address (physical)
                mov     ax,09800h   ; IDE BIOS address of memory window
                jz      NormalMode_IDE
                mov     cx,0E800h   ; IDE work address (physical)
                mov     bx,0E600h   ; IDE BIOS address (physical),ordinary
                mov     dx,063Dh
                in      al,dx
                test    al,2
                jz      @f
                mov     cx,0EA00h   ; IDE work address (physical)
        @@:     mov     dx,bx       ; 
                sub     bx,6000h    ; phisycal --> shadow
                mov     ax,bx       ; IDE BIOS address of memory window
NormalMode_IDE: mov     SegPhysIDEBIOS,dx
;                mov     SegPhysIDEwork,cx
                mov     SegMMapIDEBIOS,ax
;                mov     es,ax
                ret
GetSeg_IDEBIOS  ENDP

;--------------------------------------------------------
;       Exist_IDE_BIOS
;--------------------------------------------------------
Exist_IDE_BIOS  PROC   near
                push    es
                mov     es,SegPhysIDEBIOS
                mov     ax,es:[0009h]   ; ? C-BUS ROM
                mov     bx,es:[000Bh]   ; ? C-BUS ROM
                mov     dx,es:[0030h]  ; ? $PnP
                pop     es
                cmp     ax,0AA55h       ; C-BUS ROM signature
                jnz     NoExist_IDE_BIOS
                cmp     bl,2Ah          ; C-BUS ROM type ID
                jnz     NoExist_IDE_BIOS

                or      dx,dx         ; jmp [0030] == 00000000h
                jz      NoExist_IDE_BIOS
;                mov     dx,offset IDE_msg ; uIDE BIOS܂v
;                call    _puts
                clc
                ret
NoExist_IDE_BIOS:  
                mov     dx,offset absent_msg
                call    _puts
                stc
                ret
Exist_IDE_BIOS  ENDP


;--------------------------------------------------------------------
;       scan_pattern     ̔r[`  for IDE BIOS (type 2)
;       <input>
;       DS:SI rp^[,         CX END
;  (   ES:DI p^[ꏊ30h`  DX IDE BIOS͈̔͂̃oCg  )
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern    PROC    near
                cld
                mov     di,0030h
                sub     cx,si   ;<-------- type 2
                mov     dx,2000h-30h
                sub     dx,cx   ;<-------- type 2

                xor     bx,bx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match

                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern    ENDP
IF 0
;---------------------------------------------------------
;       Beep Tone98Set
;---------------------------------------------------------
Tone98Set       PROC    near
                push    dx
                mov DX,03FDBh        ; 3FDB
                out DX,AL
                out     5Fh,al
               xchg AL,AH
                out DX,AL
                out     5Fh,al
                pop     dx
                ret
Tone98Set       ENDP
;--------------------------------------------------------
;--------------------------------------------------------
BeepSound       PROC   near
                call    Tone98Set
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,bx
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    Tone98Set
                ret
BeepSound       ENDP
;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,4000
                mov     bx,5432h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Poop            ENDP
;--------------------------------------------------------
;       Peee
;--------------------------------------------------------
Peee            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,3000
                mov     bx,0FFF0h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Peee            ENDP
ENDIF

;--------------------------------------------------------
;       ClearMEMseg
;--------------------------------------------------------
ClearMEMseg     PROC    near
                push    es
                mov     cx,2000h/2
                mov     ax,MEMseg
                mov     es,ax
                xor     ax,ax
                mov     di,ax
           rep  stosw
                pop     es
                ret
ClearMEMseg     ENDP

;--------------------------------------------------------
;       SetChkSum        ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
SetChkSum       PROC    near
                mov     ax,MEMseg
                push    ds
                mov     ds,ax
                xor     dx,dx
                mov     si,dx
                mov     cx,(2000h/2)
                dec     cx
        @@:
                lodsw
                add     dl,al
                add     dh,ah
               loop     @b
                neg     dl
                neg     dh
                mov     ds:[si],dx
                pop     ds
                ret
SetChkSum       ENDP

;--------------------------------------------
;       DisplayEquip    
;--------------------------------------------
DisplayEquip    PROC   near
                push    ROW
                push    COLUMN
;;;;;           dec     ROW
                dec     ROW
                mov     COLUMN,69
                mov     dx,offset msg_equip1
                call    _puts
                inc     ROW
                mov     COLUMN,70
                mov     dx,offset msg_equip2
                call    _puts
                mov     al,equip ; Internal IDE,SCSI,SND BIOS enable
                call    digit_bit4
                pop     COLUMN
                pop     ROW
                ret
DisplayEquip    ENDP
msg_equip1      DB     0E1h," BIOS ",0
msg_equip2      DB     0E1h,"׸ ",0

;---------------------------------------------------

digit_1         PROC   near     ; input al
                push    si
                mov     si,offset num_space
                add     al,'0'  ; AL-->+30h  0-->"0"
                mov     cs:[si+1],al
                mov     dx,si
                call    _puts
                pop     si
                ret
num_space       DB      081h,20h,20h,0
digit_1         ENDP

;------------------------------------
;------------------------------------
AdvancePos      PROC   near
                push    dx
                mov     es,SegTVRAM ; ̕ϐ͊OIɊm肳Ă̂Ƃ
                mov     ax,80       ; Ps80
                mul     ROW         ; ̕ϐ͊OIɊm肵Ă̂Ƃ
                add     ax,COLUMN   ; ̕ϐ͊OIɊm肵Ă̂Ƃ
                shl     ax,1        ; VRAMAhXł2{
                mov     di,ax       ; DI=ɕ\JnʒuItZbgi[
                pop     dx
                ret
AdvancePos      ENDP

;------------------------------------
;------------------------------------
digit_bit4      PROC   near
                mov     dl,al
                call    AdvancePos
                mov     cx,4
NextBit:
                mov     al,0EDh
                test    dl,080h
                jz      @f
                mov     al,0ECh
        @@:     rol     dl,1
                mov     ah,00h
                mov     byte ptr es:[di+2000h],0E1h
                stosw
               loop     NextBit
                ret
digit_bit4      ENDP
;------------------------------------
;       Erase1Line
;------------------------------------
Erase1Line      PROC   near
                push    ROW
                mov     COLUMN,0
                call    AdvancePos      
                mov     ax,0020h    ; space code on VRAM
                mov     cx,80
        @@:     mov     byte ptr es:[di+2000h],0E1h
                stosw
               loop     @b
                pop     ROW
                ret
Erase1Line      ENDP
;===================================
